summaryrefslogtreecommitdiff
path: root/resources
diff options
context:
space:
mode:
authorLeah Rowe <leah@libreboot.org>2023-05-14 14:10:51 +0100
committerLeah Rowe <leah@libreboot.org>2023-05-14 14:29:06 +0100
commit963b524722c016c05be5d68d570aa9e8623b55c5 (patch)
tree0460e0896cde8fcfbe2479970ebbae6b68e659ca /resources
parentd89585fb718a4d499c877102f0b2aed7d2222b14 (diff)
download/mrc: use cleaner coding style
top-down order for all logic, and shorter code lines, conforming to rfc 2646 (no more than 80 characters) the 80-character rule is violated for variables containing long strings, such as wayback machine urls (can't be helped) a few bugs were discovered, which will be fixed in follow-up revisions, such as: * exit status not handled inside subshell * in general, exit status should be handled more explicitly, rather than relying on -e
Diffstat (limited to 'resources')
-rwxr-xr-xresources/scripts/download/mrc181
1 files changed, 94 insertions, 87 deletions
diff --git a/resources/scripts/download/mrc b/resources/scripts/download/mrc
index 49657fec..69c9eff2 100755
--- a/resources/scripts/download/mrc
+++ b/resources/scripts/download/mrc
@@ -15,17 +15,99 @@
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
-# This script assumes that the working directory is the
-# root of osboot_src or osboot git.
+[ "x${DEBUG+set}" = 'xset' ] && set -v
+set -u -e
+export PATH="${PATH}:/sbin"
# This file is forked from util/chromeos/crosfirmware.sh in coreboot cfc26ce278
-# Changes to it in osboot are copyright 2021 Leah Rowe
+# Changes to it in *this version* are copyright 2021 and 2023 Leah Rowe, under
+# the same license as above.
-[ "x${DEBUG+set}" = 'xset' ] && set -v
-set -u -e
+# use updated manifest from wayback machine, when updating mrc.bin,
+# and update the other variables below accordingly. current manifest used:
+# https://web.archive.org/web/20210211071412/https://dl.google.com/dl/edgedl/chromeos/recovery/recovery.conf
-# On some systems, `parted` and `debugfs` are located in /sbin.
-export PATH="${PATH}:/sbin"
+# the wayback machine is used so that we get the same manifest. google
+# does not seem to version the manifest, but archives are available
+
+# variables taken from that manifest:
+
+_board="peppy"
+_file="chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin"
+_url="https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
+_url2="https://web.archive.org/web/20200516070928/https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
+_sha1sum="cd5917cbe7f821ad769bf0fd87046898f9e175c8"
+_mrc_complete_hash="d18de1e3d52c0815b82ea406ca07897c56c65696"
+_mrc_complete="mrc/haswell/mrc.bin"
+
+cbdir="coreboot/default"
+cbfstool="${cbdir}/util/cbfstool/cbfstool"
+
+main()
+{
+ printf "Downloading Intel MRC blobs\n"
+
+ check_existing && exit 0
+ build_dependencies
+ fetch_mrc
+}
+
+check_existing()
+{
+ if [ ! -f ${_mrc_complete} ]; then
+ return 1
+ fi
+ printf 'found existing mrc.bin, checking its hash\n'
+ if [ "$(sha1sum ${_mrc_complete} | awk '{print $1}')" \
+ = "${_mrc_complete_hash}" ]; then
+ printf 'checksums matched, skipping downloading\n'
+ return 0
+ else
+ printf 'hashes did not match, starting over\n'
+ return 1
+ fi
+}
+
+build_dependencies()
+{
+ if [ ! -d "${cbdir}/" ]; then
+ ./download coreboot default
+ fi
+ if [ ! -f "${cbfstool}" ]; then
+ ./build module cbutils default
+ fi
+}
+
+fetch_mrc()
+{
+ mkdir -p mrc/haswell/
+
+ (
+ cd mrc/haswell/
+
+ download_image ${_url} ${_file} ${_sha1sum}
+ if [ ! -f ${_file} ]; then
+ download_image ${_url2} ${_file} ${_sha1sum}
+ fi
+ if [ ! -f $_file ]; then
+ printf "%s not downloaded / verification failed. Exiting.\n" \
+ ${_file}
+ exit 1
+ fi
+
+ extract_partition ROOT-A ${_file} root-a.ext2
+ extract_shellball root-a.ext2 chromeos-firmwareupdate-${_board}
+
+ extract_coreboot chromeos-firmwareupdate-${_board}
+
+ ../../${cbfstool} coreboot-*.bin extract -f mrc.bin \
+ -n mrc.bin -r RO_SECTION
+ rm -f "chromeos-firmwareupdate-${_board}" coreboot-*.bin \
+ "${_file}" "root-a.ext2"
+
+ printf "\n\nmrc.bin saved to ${_mrc_complete}\n\n"
+ )
+}
download_image()
{
@@ -35,7 +117,8 @@ download_image()
echo "Downloading recovery image"
curl "$_url" > "$_file.zip"
- if [ "$(sha1sum ${_file}.zip | awk '{print $1}')" = "${_sha1sum}" ]; then
+ if [ "$(sha1sum ${_file}.zip | awk '{print $1}')" = "${_sha1sum}" ]
+ then
unzip -q "${_file}.zip"
rm "${_file}.zip"
echo "Checksum verification passed for recovery image."
@@ -71,8 +154,8 @@ extract_shellball()
SHELLBALL=${2}
echo "Extracting chromeos-firmwareupdate"
- printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" | \
- debugfs ${ROOTFS} > /dev/null 2>&1
+ printf "cd /usr/sbin\ndump chromeos-firmwareupdate ${SHELLBALL}\nquit" \
+ | debugfs ${ROOTFS} > /dev/null 2>&1
}
extract_coreboot()
@@ -90,80 +173,4 @@ extract_coreboot()
rm -r "${_unpacked}"
}
-check_existing()
-{
- _mrc_complete_hash="d18de1e3d52c0815b82ea406ca07897c56c65696"
- if [ -f mrc/haswell/mrc.bin ]; then
- printf 'found existing mrc.bin, checking its hash\n'
- if [ "$(sha1sum mrc/haswell/mrc.bin | awk '{print $1}')" = "${_mrc_complete_hash}" ]; then
- printf 'checksums matched, skipping redownloading image\n'
- return 0
- else
- printf 'hashes did not match, starting over\n'
- return 1
- fi
-
- else
- return 1
- fi
-}
-
-# Skips redownloading every time the script runs
-check_existing && exit 0
-
-if [ ! -d "coreboot/default/" ]; then
- ./download coreboot default
-fi
-
-if [ ! -f "coreboot/default/util/cbfstool/cbfstool" ]; then
- ./build module cbutils default
-fi
-
-# Remove the old version that may still exist
-# ------------------------------------------------------------------------------
-
-printf "Downloading Intel MRC blobs\n"
-
-
-#rm -Rf "mrc/"
-
-mkdir -p mrc/haswell/
-
-(
-
-cd mrc/haswell/
-
-# https://web.archive.org/web/20210211071412/https://dl.google.com/dl/edgedl/chromeos/recovery/recovery.conf
-# peppy image used as defined here, mrc.bin extracted from that.
-# when wanting to use an updated version later on, just change the url and
-# sha1sums and such, in this script, based on a newer version on archive.org.
-
-# For haswell mrc.bin, used on ThinkPad T440p and W541
-_board="peppy"
-_file="chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin"
-_url="https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
-_url2="https://web.archive.org/web/20200516070928/https://dl.google.com/dl/edgedl/chromeos/recovery/chromeos_12239.92.0_peppy_recovery_stable-channel_mp-v3.bin.zip"
-_sha1sum="cd5917cbe7f821ad769bf0fd87046898f9e175c8"
-
-download_image ${_url} ${_file} ${_sha1sum}
-if [ ! -f ${_file} ]; then
- download_image ${_url2} ${_file} ${_sha1sum}
-fi
-if [ ! -f $_file ]; then
- echo "${_file} was not downloaded, or verification failed. Exiting"
- exit 1
-fi
-
-extract_partition ROOT-A ${_file} root-a.ext2
-extract_shellball root-a.ext2 chromeos-firmwareupdate-${_board}
-
-extract_coreboot chromeos-firmwareupdate-${_board}
-
-../../coreboot/default/util/cbfstool/cbfstool coreboot-*.bin extract -f mrc.bin -n mrc.bin -r RO_SECTION
-rm -f "chromeos-firmwareupdate-${_board}" coreboot-*.bin "${_file}" "root-a.ext2"
-
-printf "\n\nHaswell mrc.bin file (for T440p and W541) downloaded to mrc/haswell/mrc.bin\n\n"
-
-)
-
-exit 0
+main $@